controllers/ArmasController.php
<?php

namespace app\controllers;

use app\models\Armas;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\data\SqlDataProvider;
/**
 * ArmasController implements the CRUD actions for Armas model.
 */
class ArmasController extends Controller
{
    /**
     * @inheritDoc
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'verbs' => [
                    'class' => VerbFilter::className(),
                    'actions' => [
                        'delete' => ['POST'],
                    ],
                ],
            ]
        );
    }

    /**
     * Lists all Armas models.
     *
     * @return string
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Armas::find(),
            /*
            'pagination' => [
                'pageSize' => 50
            ],
            'sort' => [
                'defaultOrder' => [
                    'codigo_armas' => SORT_DESC,
                ]
            ],
            */
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Armas model.
     * @param int $codigo_armas Codigo Armas
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($codigo_armas)
    {
        return $this->render('view', [
            'model' => $this->findModel($codigo_armas),
        ]);
    }

    /**
     * Creates a new Armas model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    public function actionCreate()
    {
        $model = new Armas();

        if ($this->request->isPost) {
            if ($model->load($this->request->post()) && $model->save()) {
                return $this->redirect(['view', 'codigo_armas' => $model->codigo_armas]);
            }
        } else {
            $model->loadDefaultValues();
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Armas model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param int $codigo_armas Codigo Armas
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($codigo_armas)
    {
        $model = $this->findModel($codigo_armas);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            return $this->redirect(['view', 'codigo_armas' => $model->codigo_armas]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Armas model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param int $codigo_armas Codigo Armas
     * @return \yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($codigo_armas)
    {
        $this->findModel($codigo_armas)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Armas model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param int $codigo_armas Codigo Armas
     * @return Armas the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($codigo_armas)
    {
        if (($model = Armas::findOne(['codigo_armas' => $codigo_armas])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
    
    
    /**
     * Acciones para que se muestren las armas
     * que utiliza cada pirata.
     */
    
    
    public function actionEdwardteach(){
     $dataProvider = new ActiveDataProvider([
        'query' => Armas::find()
            ->select(['armas'])
            ->where(['id_piratas' => 1]),
             ]);
        return $this->render("inforarmas",[
            "dataProvider"=>$dataProvider,
        ]);
    }
    
     public function actionWilliamkidd(){
     $dataProvider = new ActiveDataProvider([
        'query' => Armas::find()
            ->select(['armas'])
            ->where(['id_piratas' => 2]),
             ]);
        return $this->render("inforarmas",[
            "dataProvider"=>$dataProvider,
        ]);
    }

     public function actionJohnroberts(){
     $dataProvider = new ActiveDataProvider([
        'query' => Armas::find()
            ->select(['armas'])
            ->where(['id_piratas' => 3]),
             ]);
        return $this->render("inforarmas",[
            "dataProvider"=>$dataProvider,
        ]);
    }

     public function actionJohnrackham(){
     $dataProvider = new ActiveDataProvider([
        'query' => Armas::find()
            ->select(['armas'])
            ->where(['id_piratas' => 4]),
             ]);
        return $this->render("inforarmas",[
            "dataProvider"=>$dataProvider,
        ]);
    }
    
     public function actionCharlesvane(){
     $dataProvider = new ActiveDataProvider([
        'query' => Armas::find()
            ->select(['armas'])
            ->where(['id_piratas' => 5]),
             ]);
        return $this->render("inforarmas",[
            "dataProvider"=>$dataProvider,
        ]);
    }
    
     public function actionAnneyboney(){
     $dataProvider = new ActiveDataProvider([
        'query' => Armas::find()
            ->select(['armas'])
            ->where(['id_piratas' => 6]),
             ]);
        return $this->render("inforarmas",[
            "dataProvider"=>$dataProvider,
        ]);
    }
    
     public function actionMaryread(){
     $dataProvider = new ActiveDataProvider([
        'query' => Armas::find()
            ->select(['armas'])
            ->where(['id_piratas' => 7]),
             ]);
        return $this->render("inforarmas",[
            "dataProvider"=>$dataProvider,
        ]);
    }
    
     public function actionZhengshi(){
     $dataProvider = new ActiveDataProvider([
        'query' => Armas::find()
            ->select(['armas'])
            ->where(['id_piratas' =>8]),
             ]);
        return $this->render("inforarmas",[
            "dataProvider"=>$dataProvider,
        ]);
    }
    
    public function actionCheung(){
     $dataProvider = new ActiveDataProvider([
        'query' => Armas::find()
            ->select(['armas'])
            ->where(['id_piratas' =>9]),
             ]);
        return $this->render("inforarmas",[
            "dataProvider"=>$dataProvider,
        ]);
    }

     public function actionOlivier(){
     $dataProvider = new ActiveDataProvider([
        'query' => Armas::find()
            ->select(['armas'])
            ->where(['id_piratas' =>10]),
             ]);
        return $this->render("inforarmas",[
            "dataProvider"=>$dataProvider,
        ]);
    }
    
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use yii\data\SqlDataProvider;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }
    
    //Renderizar la vista del mar caribe, oceano índico y mar de china
    public function actionCaribe() {
        return $this->render('caribe');
    }
    public function actionIndico(){
        return $this->render('indico');
    }
    public function actionChina(){
        return $this->render('china');
    }
    
    public function actionGraficos(){
        return $this->render('graficos');
    }
    
    public function actionArmascaribe(){
        return $this->render('armascaribe');
    }
    
    public function actionArmasindico(){
        return $this->render('armasindico');
    }
    
    public function actionArmaschina(){
        return $this->render('armaschina');
    }
    
        public function actionGraficosbarcos(){
        return $this->render('graficosbarcos');
    }
    
    /**
     * Login action.
     *
     * @return Response|string
     */
    public function actionLogin()
    {
        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }

        $model = new LoginForm();
        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            return $this->goBack();
        }

        $model->password = '';
        return $this->render('login', [
            'model' => $model,
        ]);
    }

    /**
     * Logout action.
     *
     * @return Response
     */
    public function actionLogout()
    {
        Yii::$app->user->logout();

        return $this->goHome();
    }

    /**
     * Displays contact page.
     *
     * @return Response|string
     */
    public function actionContact()
    {
        $model = new ContactForm();
        if ($model->load(Yii::$app->request->post()) && $model->contact(Yii::$app->params['adminEmail'])) {
            Yii::$app->session->setFlash('contactFormSubmitted');

            return $this->refresh();
        }
        return $this->render('contact', [
            'model' => $model,
        ]);
    }

    /**
     * Displays about page.
     *
     * @return string
     */
    public function actionAbout()
    {
        return $this->render('about');
    }
    

}

views/site/armascaribe.php
<?php
use yii\bootstrap4\Modal;
use yii\helpers\Html;
use yii\bootstrap4\Button;
use yii\bootstrap4\Dropdown;

/** @var yii\web\View $this */


$this->title = 'Mar Caribe';
$this->registerJsFile('@web/js/sitejs.js');

?>

    <!--Botón para volver al mapamundi-->
<?= Html::a($text = "Mapamundi", ['site/index'], ['class' => 'btn btn-mapamundi btn-dark']) ?>

<div class="containercaribe" style="z-index: 1;">  
    
<h2 style="text-align: center;"> Bienvenido al Mar Caribe polizón</h2>


<!-- Menú lateral -->
<p class="textlat"> Selecciona una de las opciones: </p>
    <div class="dot"></div>
    
      <?= Html::a('Mapa Caribe', ['site/caribe'], ['class'=>'btn btn-dark btn-mapassecun'])?>
</div>    
    
    <!-- Opción del desplegable para ver las armas -->
   <div class="dot2"></div> 
   
        <?= Html::a('Armas', ['site/armascaribe'], ['class'=>'btn btn-dark btn-datos'])?>
   <!-- Botones para ver las armas -->
    <div class="selarmas" style="position: absolute;">

        
        
        <h2 style="font-size: 40px;"> Selecciona un pirata </h2>
        
                <?= Html::a('Edward Teach', ['armas/edwardteach'], ['class'=>'btn btn-dark btn-armas'])?>
                <?= Html::a('John Roberts', ['armas/johnroberts'], ['class'=>'btn btn-dark btn-armas'])?>
                <?= Html::a('John Rackham', ['armas/johnrackham'], ['class'=>'btn btn-dark btn-armas'])?>
                <?= Html::a('Charles Vane', ['armas/charlesvane'], ['class'=>'btn btn-dark btn-armas'])?>
                <?= Html::a('Anney Boney', ['armas/anneyboney'], ['class'=>'btn btn-dark btn-armas'])?>
                <?= Html::a('Mary Read', ['armas/maryread'], ['class'=>'btn btn-dark btn-armas'])?>

  
        
    </div>
     
 





   

views/site/armaschina.php
<?php
use yii\bootstrap4\Modal;
use yii\helpers\Html;
use yii\bootstrap4\Button;
use yii\web\JsExpression;
/** @var yii\web\View $this */


$this->title = 'Mar de China';

?>

<?= Html::a($text = "Mapamundi", ['site/index'], ['class' => 'btn btn-mapamundi btn-dark']) ?>

<div class="containerchina" style="z-index: 1;">    
<h2 style="text-align: center;"> Bienvenido al Mar de China polizón</h2>

<!-- Menú lateral -->
<p class="textlat"> Selecciona una de las opciones: </p>
    <div class="dot"></div>
    <?= Html::a('Mapa China', ['site/china'], ['class'=>'btn btn-dark btn-mapassecun'])?>
  </div>  

<!-- Opción del desplegable para ver las armas -->
   <div class="dot2"></div> 
   
<?= Html::a('Armas', ['site/armaschina'], ['class'=>'btn btn-dark btn-datos'])?>
   
   <!-- Botones para ver las armas --> 
    <div class="selarmas" style="position: absolute;">
     
            <h2 style="font-size: 40px;"> Selecciona un pirata </h2>
               
                <?= Html::a('Zheng Shi', ['armas/zhengshi'], ['class'=>'btn btn-dark btn-armas'])?>
                <?= Html::a('Cheung Po Tsai', ['armas/cheung'], ['class'=>'btn btn-dark btn-armas'])?>
 
        
    </div>

views/site/armasindico.php
<?php
use yii\bootstrap4\Modal;
use yii\helpers\Html;
use yii\bootstrap4\Button;

/** @var yii\web\View $this */


$this->title = 'Océano índico';
$this->registerJsFile('@web/js/sitejs.js');
?>
<?= Html::a($text = "Mapamundi", ['site/index'], ['class' => 'btn btn-mapamundi btn-dark']) ?>

<div class="containerindico" style="z-index: 1;">    
<h2 class="textind"> Bienvenido al Océano Índico polizón</h2>

<!-- Menú lateral -->
<p class="textlat"> Selecciona una de las opciones: </p>
<div class="dot"></div>
    <?= Html::a('Mapa Índico', ['site/indico'], ['class'=>'btn btn-dark btn-mapassecun'])?>
 </div>   
<!-- Opción del desplegable para ver las armas -->
     <div class="dot2"></div> 
     
      <?= Html::a('Armas', ['site/armasindico'], ['class'=>'btn btn-dark btn-datos'])?>
    <!-- Botones para ver las armas -->
    <div class="selarmas" style="position: absolute;">
       
            <h2 style="font-size: 40px;"> Selecciona un pirata </h2>
            
                <?= Html::a('William Kidd', ['armas/williamkidd'], ['class'=>'btn btn-dark btn-armas'])?>
                <?= Html::a('Olivier Levasseur', ['armas/olivier'], ['class'=>'btn btn-dark btn-armas'])?>
      
    </div>
    
         
 




   

views/site/caribe.php
<?php
use yii\bootstrap4\Modal;
use yii\helpers\Html;
use yii\bootstrap4\Button;
use yii\bootstrap4\Dropdown;

/** @var yii\web\View $this */


$this->title = 'Mar Caribe';
$this->registerJsFile('@web/js/sitejs.js');

?>

    <!--Botón para volver al mapamundi-->
<?= Html::a($text = "Mapamundi", ['site/index'], ['class' => 'btn btn-mapamundi btn-dark']) ?>

<div class="containercaribe" style="z-index: 1;">  
    
<h2 style="text-align: center; font-size: 50px;"> Bienvenido al Mar Caribe, polizón</h2>


<!-- Menú lateral -->
<p class="textlat"> Selecciona una de las opciones: </p>
    <div class="dot"></div>
    
        <?= Html::a('Mapa Caribe', ['site/caribe'], ['class'=>'btn btn-dark btn-mapassecun'])?>
    
       <!-- Mapa y botones de piratas -->
    <div class="mapa">
        <?php   
        echo Html::img('@web/img/Caribe.png', ['class' => 'img-fluid', 'alt' => 'Mar Caribe']);
        echo Html::a(Html::img('@web/img/calavera.png', ['alt' => 'Imagen del botón', 'class' => 'imagen-pequena',]),['piratas/edwardteach'], ['class' => ' btn-gen btn-et', 'title' => 'Edward Teach']);
        echo Html::a(Html::img('@web/img/calavera.png', ['alt' => 'Imagen del botón', 'class' => 'imagen-pequena',]),['piratas/johnroberts'], ['class' => ' btn-gen btn-jr', 'title' => 'John Roberts']);
        echo Html::a(Html::img('@web/img/calavera.png', ['alt' => 'Imagen del botón', 'class' => 'imagen-pequena',]),['piratas/johnrackham'], ['class' => ' btn-gen btn-cj', 'title' => 'John Rackham']);
        echo Html::a(Html::img('@web/img/calavera.png', ['alt' => 'Imagen del botón', 'class' => 'imagen-pequena',]),['piratas/charlesvane'], ['class' => ' btn-gen btn-cv', 'title' => 'Charles Vane']);
        echo Html::a(Html::img('@web/img/calavera.png', ['alt' => 'Imagen del botón', 'class' => 'imagen-pequena',]),['piratas/anneyboney'], ['class' => ' btn-gen btn-ab', 'title' => 'Anney Bonney']);
        echo Html::a(Html::img('@web/img/calavera.png', ['alt' => 'Imagen del botón', 'class' => 'imagen-pequena',]),['piratas/maryread'], ['class' => ' btn-gen btn-mr', 'title' => 'Mary Read']);

        ?>
    </div>
 </div>    
    <!-- Opción del desplegable para ver las armas -->
   <div class="dot2"></div> 
    <?= Html::a('Armas', ['site/armascaribe'], ['class'=>'btn btn-dark btn-datos'])?>
   

     
 





   

views/site/china.php
<?php
use yii\bootstrap4\Modal;
use yii\helpers\Html;
use yii\bootstrap4\Button;
use yii\web\JsExpression;
/** @var yii\web\View $this */


$this->title = 'Mar de China';

?>

<?= Html::a($text = "Mapamundi", ['site/index'], ['class' => 'btn btn-mapamundi btn-dark']) ?>

<div class="containerchina" style="z-index: 1;">    
<h2 style="text-align: center; font-size: 50px;"> Bienvenido al Mar de China, polizón</h2>

<!-- Menú lateral -->
<p class="textlat"> Selecciona una de las opciones: </p>
 <?= Html::a('Mapa China', ['site/china'], ['class'=>'btn btn-dark btn-mapassecun'])?>
    <div class="dot"></div>
     <!-- Mapa y botones de piratas -->
    <div class="mapa">
        <?php
       
        echo Html::img('@web/img/china.png', ['alt' => 'Mar de China']); 
        echo Html::a(Html::img('@web/img/calavera.png', ['alt' => 'Imagen del botón', 'class' => 'imagen-pequena',]),['piratas/zheng'], ['class' => ' btn-gen btn-zs', 'title' => 'Zheng Shi']);
        echo Html::a(Html::img('@web/img/calavera.png', ['alt' => 'Imagen del botón', 'class' => 'imagen-pequena',]),['piratas/cheung'], ['class' => ' btn-gen btn-cpt', 'title' => 'Cheung Po Tsai']);
       
        ?>
    </div>
  </div>  

<!-- Opción del desplegable para ver las armas -->
   <div class="dot2"></div> 
     <?= Html::a('Armas', ['site/armaschina'], ['class'=>'btn btn-dark btn-datos'])?>

views/site/graficos.php
<?php

use yii\bootstrap4\Modal;
use yii\helpers\Html;
use yii\helpers\Url;
use yii\bootstrap4\Button;
use dosamigos\chartjs\ChartJs;
use yii\db\Query;

// Consulta para obtener el número de guerras libradas.
$query = new Query();
$guerras = $query->select(['p.nombre AS pais', 'COUNT(pa.id_guerras) as num_guerras'])
        ->from('paises p')
        ->leftJoin('participan pa', 'p.id = pa.id_paises')
        ->groupBy('p.id')
        ->all();

$pais = [];
$nguerras = [];

foreach ($guerras as $guerra) {
    $pais[] = $guerra['pais'];
    $nguerras[] = $guerra['num_guerras'];
}

//Consulta para obtener el número de piratas contratados.
$query = new Query();
$contratos = $query->select(['p.nombre AS pais', 'COUNT(co.id_piratas) as num_piratas'])
        ->from('paises p')
        ->leftJoin('contratan co', 'p.id = co.id_paises')
        ->groupBy('p.id')
        ->all();

$contrato = [];
$npiratas = [];

foreach ($contratos as $contrat) {
    $contrato[] = $contrat['pais'];
    $npiratas[] = $contrat['num_piratas'];
}

?>

<!-- Botón para volver al mapamundi -->
<?= Html::a($text = "Mapamundi", ['site/index'], ['class' => 'btn btn-mapamundi btn-dark']) ?>

<!-- Título de la página -->
<h1 style="margin-top: 50px; margin-left: 68.5%;">Información en gráficos </h1>


<!-- Menú lateral -->
<p class="textlat"> Selecciona una de las opciones: </p>  

<!-- Punto lateral -->
<div class="dot"></div>

<!-- Opción de los países en el menú lateral como un desplegable -->
<?php
echo Button::widget([
    'label' => 'Países',
    'options' => [
        'id' => 'btnToggle',
        'class' => 'btn btn-dark active btn-mapassecun ',
        'data-toggle' => 'collapse',
        'data-target' => '#paises',
        'aria-expanded' => 'true',
        'aria-controls' => 'paises'
    ],
]);
?>

<?php
echo Html::beginTag('paises', ['class' => 'collapse show', 'id' => 'paises']);
?>

<div style="margin-left: 12.5%;">    

    <!-- Gráfico de guerras -->     
    <div style="height: 500px; width: 500px; margin-top: 50px; margin-left: 175px; position: absolute; z-index: 1;">

        <h2> Nº de guerras por país  </h2>

        <?=
        ChartJs::widget([
            'type' => 'line',
            'options' => [
                'height' => 50,
                'width' => 50
            ],
            'data' => [
                'labels' => $pais,
                'datasets' => [
                    [
                        'label' => $pais,
                        'backgroundColor' => "rgba(255, 20, 36, 0.5)",
                        'borderColor' => "rgba(179,181,198,1)",
                        'pointBackgroundColor' => "rgba(179,181,198,1)",
                        'pointBorderColor' => "#fff",
                        'pointHoverBackgroundColor' => "#fff",
                        'pointHoverBorderColor' => "rgba(179,181,198,1)",
                        'data' => $nguerras
                    ]
                ]
            ]
        ]);
        ?>
    </div>

    <!-- Gráfico de contratos -->
    <div style="height: 500px; width: 500px; margin-top: 50px; margin-left: 1000px; position: absolute; z-index: 1;">
        <h2> Nº de piratas contratados por país </h2>
        <?=
        ChartJs::widget([
            'type' => 'bar',
            'options' => [
                'height' => 50,
                'width' => 50
            ],
            'data' => [
                'labels' => $contrato,
                'datasets' => [
                    [
                        'label' => $contrato,
                        'backgroundColor' => "rgba(255, 20, 36, 0.5)",
                        'borderColor' => "rgba(179,181,198,1)",
                        'pointBackgroundColor' => "rgba(179,181,198,1)",
                        'pointBorderColor' => "#fff",
                        'pointHoverBackgroundColor' => "#fff",
                        'pointHoverBorderColor' => "rgba(179,181,198,1)",
                        'data' => $npiratas
                    ]
                ]
            ]
        ]);
        ?>
    </div>   
</div>
<?php
echo Html::endTag('paises');
?>

<!-- Punto lateral -->
<div class="dot2"></div> 

<!-- Botón de acceso a la información gráfica sobre los barcos -->
<?= Html::a('Barcos', ['site/graficosbarcos'], ['class'=>'btn btn-dark btn-datos'])?>

views/site/graficosbarcos.php
<?php

use yii\bootstrap4\Modal;
use yii\helpers\Html;
use yii\helpers\Url;
use yii\bootstrap4\Button;
use dosamigos\chartjs\ChartJs;
use yii\db\Query;


//Consulta para los barcos
$query = new Query();
$barcos = $query->select(['b.nombre', 'b.numero_canones'])
        ->from('barcos b')
        ->all();

$nombrebarco = [];
$ncanones = [];

foreach ($barcos as $barco) {
    $nombrebarco[] = $barco['nombre'];
    $ncanones[] = $barco['numero_canones'];
}
?>

<!-- Botón para volver al mapamundi -->
<?= Html::a($text = "Mapamundi", ['site/index'], ['class' => 'btn btn-mapamundi btn-dark']) ?>

<!-- Título de la página -->
<h1 style="margin-top: 50px; margin-left: 68.5%;">Información en gráficos </h1>

<!<!-- Menú lateral -->
<p class="textlat"> Selecciona una de las opciones: </p>  

<!-- Punto lateral -->
<div class="dot"></div>

<!-- Botón para acceder a la información en gráficos de los paises -->
<?= Html::a('Países', ['site/graficos'], ['class'=>'btn btn-dark btn-mapassecun'])?>

<!-- Punto lateral -->
<div class="dot2"></div> 

<!-- Opción de los países en el menú lateral como un desplegable -->
<?php
echo Button::widget([
    'label' => 'Barcos',
    'options' => [
        'id' => 'btnToggle',
        'class' => 'btn btn-dark active btn-datos ',
        'data-toggle' => 'collapse',
        'data-target' => '#barcos',
        'aria-expanded' => 'true',
        'aria-controls' => 'barcos'
    ],
]);
?>

<!-- Gráfico de los barcos -->
<div class="selarmas" style="position: absolute;">
    <?php
    echo Html::beginTag('barcos', ['class' => 'collapse show', 'id' => 'barcos']);
    ?>

    <div style="height: 600px; width: 600px; margin-top: 15px; margin-left: 180px; position: absolute; z-index: 1;">

        <h2> Nº de cañones por barco</h2>

        <?=
        ChartJs::widget([
            'type' => 'bar',
            'options' => [
                'height' => 400,
                'width' => 400
            ],
            'data' => [
                'labels' => $nombrebarco,
                'datasets' => [
                    [
                        'label' => $nombrebarco,
                        'backgroundColor' => "rgba(255, 20, 36, 0.5)",
                        'borderColor' => "rgba(179,181,198,1)",
                        'pointBackgroundColor' => "rgba(179,181,198,1)",
                        'pointBorderColor' => "#fff",
                        'pointHoverBackgroundColor' => "#fff",
                        'pointHoverBorderColor' => "rgba(179,181,198,1)",
                        'data' => $ncanones
                    ]
                ]
            ]
        ]);
        ?>
    </div>

    <?php
    echo Html::endTag('barcos');
    ?>

</div>

views/site/index.php
<?php
use yii\bootstrap4\Modal;
use yii\helpers\Html;
use yii\helpers\Url;
/** @var yii\web\View $this */

$this->registerJs(
    "
    $(document).ready(function(){
        $('#popup-modal').modal('show');
    });
    ",
    \yii\web\View::POS_READY
);

$this->title = 'Mapamundi';
$this->registerJsFile('@web/js/sitejs.js');

?>
<!-- Botón para ir a la pestaña de gráficos -->
<?= Html::a($text = "Gráficos", ['site/graficos'], ['class' => 'btn btn-graficos btn-dark']) ?>


<!-- Código del popup-->
<div id="popup-modal" class="modal fade" tabindex="-1" role="dialog">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-body">
                <?= $this->renderAjax('_popup') ?>
            </div>
        </div>
    </div>
</div>

<!-- Código del mapa con sus botones -->
<div class="container" style="z-index: 1;">    
    
    <div class="mapa">
            <?= Html::img('@web/img/Mapamundi.png', ['alt' => 'Mapamundi']) ?>
        
            <?= Html::a($text = "Mar Caribe", ['site/caribe'], ['class' => 'btn-gen btn-caribe']) ?>
            <?= Html::a($text = "Océano Índico", ['site/indico'], ['class' => 'btn-gen btn-indico']) ?>
            <?= Html::a($text = "Mar de China", ['site/china'], ['class' => 'btn-gen btn-china']) ?>
    </div> 
    
        
</div> 


   